/*
 * main.c
 *
 * Created: 7/21/2023 5:12:02 PM
 *  Author: arunr
 */ 
#define F_CPU 1000000
#include <xc.h>
#include <util/delay.h>
#include <stdio.h>
#include <string.h>
#include "uart.h"

void ADC_init (void)
{
	ADMUX = 1<<MUX0;  // ADC1 with PB2, Vcc as reference
	ADCSRA = 1<<ADEN;  // Enable ADC
	ADCSRA |= 1<<ADPS2;  // PSC = 16
//	ADCSRA = (1<<ADEN)|(1<<ADPS2);
}

uint16_t ADC_Convert (void)
{
	ADCSRA |= 1<<ADSC;  // start conversion
	while ((ADCSRA&(1<<ADSC)) == 1){}  // wait for the conversion to finish
	uint8_t adcl = ADCL; // read ADCL register
	uint8_t adch = ADCH; // read ADCH Register
	uint16_t val = ((adch<<8)|adcl)&0x3FF;  // combine into single 10 bit value, 0x3FF-> 0b11 1111 1111	 
	return val;
}


uint16_t ADC_VAl = 0;  // 10 bit ADC value 
float Vin = 0.0;  // The voltage on the input pin
char Vin_char[4];  // The character array to store the converted float value 
char ADC_VAL_Char[20];  // The character array to store All the data (ADC value + converted float value)



int main(void)
{
	uart_init();
	ADC_init();
    while(1)
    {
		ADC_VAl = ADC_Convert();
		sprintf(ADC_VAL_Char, "%u    ", ADC_VAl);
		
		
		//Get the Voltage In on the pin
		Vin = ADC_VAl*4.85/1024.0;  // I was getting 4.85 on the input pin when the potentiometer was at max
		uint16_t Vinteger = Vin*100;   // 3.24*100=324
		Vin_char[0] = (Vinteger/100)+48;  // 324/100 = 3, 3+48 = '3' (check ascii table)
		Vin_char[1] = '.';  // decimal
		Vin_char[2] = ((Vinteger%100)/10)+48;  // 324%100 = 24, 24/10 = 2, 2+48 = '2' (check ascii table)
		Vin_char[3] = (Vinteger%10)+48;  // 324%10 = 4, 4+48 = '4' (check ascii table)
		
		strncat(ADC_VAL_Char, Vin_char, 4);
		strncat(ADC_VAL_Char, "V\n",2);
		
		
		uart_str(ADC_VAL_Char);
		_delay_ms(200);
    }
}